## primer3 2.3.7

=== debian/changelog ===
primer3 (2.3.7-3) unstable; urgency=medium

  [ Andreas Tille ]
  * debhelper 10
  * d/watch: version=4

  [ Helmut Grohne ]
  * Fix FTCBFS: Pass CXX as CPP (Closes: #851230)

 -- Andreas Tille <tille@debian.org>  Fri, 13 Jan 2017 08:32:57 +0100

primer3 (2.3.7-2) unstable; urgency=medium

  * Team Upload
  [ Andreas Tille ]
  * Moved packaging from SVN to Git
  * cme fix dpkg-control
  * better hardening
  * split example data for test into separate arch all package
  * add lintian override for empty directories

  [ Canberk Koç ]
  * Autopkgtest added
  * debian/rules:
    - added dh_clean to override_dh_auto_test section
    - sed perl interpreter path
  
 -- Canberk Koç <canberkkoc@gmail.com>  Mon, 27 Jun 2016 04:28:31 +0300

primer3 (2.3.7-1) unstable; urgency=medium

  * New upstream version
  * Moved debian/upstream to debian/upstream/metadata
  * cme fix dpkg-control

 -- Andreas Tille <tille@debian.org>  Thu, 10 Mar 2016 18:56:25 +0100

=== debian/control ===
Source: primer3
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steffen Moeller <moeller@debian.org>,
           Charles Plessy <plessy@debian.org>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 10)
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/primer3.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/primer3.git
Homepage: http://primer3.sourceforge.net

Package: primer3
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: ncbi-epcr
Enhances: emboss
Description: tool to design flanking oligo nucleotides for DNA amplification
 Primer3 picks primers for Polymerase Chain Reactions (PCRs), considering as
 criteria oligonucleotide melting temperature, size, GC content and
 primer-dimer possibilities, PCR product size, positional constraints within
 the source sequence, and miscellaneous other constraints. All of these
 criteria are user-specifiable as constraints, and some are specifiable as
 terms in an objective function that characterizes an optimal primer pair.

Package: primer3-examples
Architecture: all
Depends: ${misc:Depends}
Suggests: primer3
Description: tool to design flanking oligo nucleotides for DNA amplification (examples)
 Primer3 picks primers for Polymerase Chain Reactions (PCRs), considering as
 criteria oligonucleotide melting temperature, size, GC content and
 primer-dimer possibilities, PCR product size, positional constraints within
 the source sequence, and miscellaneous other constraints. All of these
 criteria are user-specifiable as constraints, and some are specifiable as
 terms in an objective function that characterizes an optimal primer pair.
 .
 This package contains example data to test the package.

=== debian/rules ===
#!/usr/bin/make -f

# Does not build when using +all
# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

DEBPKGNAME := $(shell dpkg-parsechangelog | awk '/^Source:/ {print $$2}')
sampledir:=$(CURDIR)/debian/$(DEBPKGNAME)-examples/usr/share/doc/$(DEBPKGNAME)/examples

%:
	dh $@ --sourcedirectory=src

override_dh_auto_build:
	dh_auto_build -- 'CPP=$$(CXX)'

override_dh_auto_test:
	dh_auto_test --sourcedirectory=test
	dh clean --sourcedirectory=test


override_dh_installexamples:
	dh_installexamples
	mkdir -p $(sampledir)/test;
	mkdir -p $(sampledir)/src;
	cp -aR ./test/* $(sampledir)/test;
	cp -aR ./src/humrep_and_simple.txt $(sampledir)/src;
	cp primer*.txt $(sampledir)/;
	chmod -x $(sampledir)/test/thal*;
	sed -i 's#/usr/local/bin/perl#/usr/bin/perl#' $(sampledir)/test/long_seq_tm_test.pl ;
	sed -i 's#/usr/local/bin/perl#/usr/bin/perl#' $(sampledir)/test/vgrep.pl ;

=== debian/watch ===
version=4
http://sf.net/primer3/primer3-[-src]*([\d.]*)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## primer3 2.4.0

=== src/Makefile ===
# ======================================================================
# (c) Copyright 1996,1997,1998,1999,2000,2001,2004,2006,2007,2008,2009
# Whitehead Institute for Biomedical Research, Steve Rozen, 
# Andreas Untergasser and Helen Skaletsky
# All rights reserved.
# 
#   This file is part of primer3, the libprimer3 library, the oligotm 
#   library and the dpal library.
#
#   Primer3 and the libraries above are free software; you can
#   redistribute them and/or modify them under the terms of the GNU
#   General Public License as published by the Free Software Foundation;
#   either version 2 of the License, or (at your option) any later
#   version.
#
#   This software is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this file (file gpl-2.0.txt in the source distribution); if
#   not, write to the Free Software Foundation, Inc., 51 Franklin St,
#   Fifth Floor, Boston, MA 02110-1301 USA
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# ======================================================================

# ======================================================================
# CITING PRIMER3
# 
# Steve Rozen and Helen J. Skaletsky (2000) Primer3 on the WWW for
# general users and for biologist programmers. In: Krawetz S, Misener S
# (eds) Bioinformatics Methods and Protocols: Methods in Molecular
# Biology. Humana Press, Totowa, NJ, pp 365-386.  Source code available
# from https://github.com/primer3-org/primer3
# ======================================================================

# For VALGRIND -- see end of this makefile for testing primer3_core
# with valgrind, a leak and memory access checker.
TESTOPTS= 
WINMAKE=mingw32-make

LDLIBS     = -lm
AR         = ar
CC         = gcc
CPP        = g++
O_OPTS     = -O2
CC_OPTS    = -g -Wall -D__USE_FIXED_PROTOTYPES__
P_DEFINES  =

CFLAGS  = $(CC_OPTS) $(O_OPTS)
LDFLAGS = -g
# Note, for profiling, use
# make O_OPTS='-pg -O0' LDFLAGS='-g -pg'

# ======================================================================
# If you have trouble with library skew when moving primer3 executables
# between systems, you might want to set LIBOPTS to -static
LIBOPTS =

ifeq ($(TESTOPTS),--windows)
	PRIMER_EXE      = primer3_core.exe
	NTDPAL_EXE      = ntdpal.exe
	NTTHAL_EXE      = ntthal.exe
	OLIGOTM_EXE     = oligotm.exe
	LONG_SEQ_EXE	= long_seq_tm_test.exe
	MASKER_EXE      = primer3_masker.exe
else
	PRIMER_EXE      = primer3_core
	NTDPAL_EXE      = ntdpal
	NTTHAL_EXE      = ntthal
	OLIGOTM_EXE     = oligotm
	LONG_SEQ_EXE	= long_seq_tm_test
	MASKER_EXE      = primer3_masker
endif
LIBOLIGOTM      = liboligotm.a
LIBOLIGOTM_DYN  = liboligotm.so.1.2.0
LIBDPAL         = libdpal.a
LIBDPAL_DYN     = libdpal.a.so.1.0.0
LIBTHAL         = libthal.a
LIBTHAL_DYN     = libthal.a.so.1.0.0
LIBPRIMER3      = libprimer3.a
LIBPRIMER3_DYN  = libprimer3.so.1.0.0
LIBMASKER       = libmasker.a
LIBMASKER_DYN   = libmasker.a.so.1.0.0
LIBRARIES       = $(LIBPRIMER3) $(LIBDPAL) $(LIBTHAL) $(LIBOLIGOTM) $(LIBMASKER)
DYNLIBS         = $(LIBPRIMER3_DYN) $(LIBDPAL_DYN) $(LIBTHAL_DYN) $(LIBOLIGOTM_DYN) $(LIBMASKER_DYN)
RANLIB          = ranlib

PRIMER_OBJECTS1=primer3_boulder_main.o\
                format_output.o\
                read_boulder.o\
                print_boulder.o\
                masker.o

PRIMER_OBJECTS=$(PRIMER_OBJECTS1) $(LIBRARIES)
PRIMER_DYN_OBJECTS=$(PRIMER_OBJECTS1) $(DYNLIBS)
# These are files generated by running ./primer3_core < ../example
example_files=example.for example.rev example.int

EXES=$(PRIMER_EXE) $(NTDPAL_EXE) $(NTTHAL_EXE) $(OLIGOTM_EXE) $(LONG_SEQ_EXE) $(MASKER_EXE)

all: $(EXES) $(LIBRARIES)

clean_src:
ifeq ($(TESTOPTS),--windows)
	del /Q /F *.o $(EXES) *~ $(LIBRARIES) $(example_files) core ..\*~
else
	-rm -f *.o $(EXES) *~ $(LIBRARIES) $(DYNLIBS) $(example_files) core ../*~
endif

clean: clean_src
ifeq ($(TESTOPTS),--windows)
	cd ..\test & $(WINMAKE) clean TESTOPTS=$(TESTOPTS)
else
	cd ../test/; make clean
endif

$(LIBOLIGOTM): oligotm.o
	$(AR) rv $@ oligotm.o
	$(RANLIB) $@

$(LIBOLIGOTM_LIB): oligotm.o
	$(CC) -shared -W1,-soname,liboligotm.so.1 -o $(LIBOLIGOTM_DYN) oligotm.o

$(LIBDPAL): dpal_primer.o
	$(AR) rv $@ dpal_primer.o
	$(RANLIB) $@

$(LIBDPAL_DYN): dpal_primer.o
	$(CC) -shared -W1,-soname,libdpal.so.1 -o $(LIBDPAL_DYN_LIB) dpal_primer.o

$(LIBTHAL): thal_primer.o
	$(AR) rv $@ thal_primer.o
	$(RANLIB) $@

$(LIBTHAL_DYN): thal_primer.o
	$(CC) -shared -W1,-soname,libthal.so.1 -o $(LIBTHAL_DYN_LIB) thal_primer.o

$(LIBPRIMER3): libprimer3.o p3_seq_lib.o
	$(AR) rv $@ libprimer3.o p3_seq_lib.o
	$(RANLIB) $@

$(LIBPRIMER3_DYN): libprimer3.o p3_seq_lib.o
	$(CC) -shared -W1,-soname,liprimer3.so.1 -o $(LIBPRIMER3_DYN) libprimer3.o p3_seq_lib.o

$(LIBMASKER): masker.o
	$(AR) rv $@ masker.o
	$(RANLIB) $@
               
$(LIBMASKER_DYN): masker.o
	$(CC) -shared -W1,-soname,libmasker.so.1 -o $(LIBMASKER_DYN) masker.o

$(PRIMER_EXE): $(PRIMER_OBJECTS)
	$(CPP) $(LDFLAGS) -o $@ $(PRIMER_OBJECTS) $(LIBOPTS) $(LDLIBS)

libprimer3.o: libprimer3.c libprimer3.h p3_seq_lib.h dpal.h thal.h oligotm.h
	$(CPP) -c $(CFLAGS) -Wno-deprecated $(P_DEFINES) -o $@ libprimer3.c

$(NTDPAL_EXE): ntdpal_main.o dpal.o
	$(CPP) $(LDFLAGS) -o $@ ntdpal_main.o dpal.o

$(NTTHAL_EXE): thal_main.o thal.o
	$(CPP) $(LDFLAGS) -o $@ thal_main.o thal.o $(LDLIBS)

$(OLIGOTM_EXE): oligotm_main.c oligotm.h $(LIBOLIGOTM)
	$(CPP) $(CFLAGS) -o $@ oligotm_main.c $(LIBOLIGOTM) $(LIBOPTS) $(LDLIBS)

$(LONG_SEQ_EXE): long_seq_tm_test_main.c oligotm.o
	$(CPP) $(CFLAGS) -o $@ long_seq_tm_test_main.c oligotm.o $(LIBOPTS) $(LDLIBS)

$(MASKER_EXE): masker_main.c $(LIBRARIES)
	$(CPP) $(CFLAGS) -o $@ masker_main.c $(LIBRARIES) $(LIBOPTS) $(LDLIBS)

read_boulder.o: read_boulder.c read_boulder.h libprimer3.h dpal.h thal.h p3_seq_lib.h 
	$(CPP) -c $(CFLAGS) $(P_DEFINES) -o $@ read_boulder.c

print_boulder.o: print_boulder.c print_boulder.h libprimer3.h p3_seq_lib.h 
	$(CPP) -c $(CFLAGS) $(P_DEFINES) -o $@ print_boulder.c

dpal.o: dpal.c dpal.h
	$(CPP) -c $(CFLAGS) -o $@ dpal.c

# We use '-ffloat-store' on windows to prevent undesirable
# precision which may lead to differences in floating point results.
thal.o: thal.c thal.h
	$(CPP) -c $(CFLAGS) -ffloat-store -o $@ thal.c

p3_seq_lib.o: p3_seq_lib.c p3_seq_lib.h libprimer3.h
	$(CPP) -c $(CFLAGS) -o $@ p3_seq_lib.c

dpal_primer.o: dpal.c dpal.h
	$(CPP) -c $(CFLAGS) $(P_DEFINES) -o $@ dpal.c

thal_primer.o: thal.c thal.h
	$(CPP) -c $(CFLAGS) -ffloat-store $(P_DEFINES) -o $@ thal.c

format_output.o: format_output.c format_output.h libprimer3.h dpal.h thal.h p3_seq_lib.h 
	$(CPP) -c $(CFLAGS) $(P_DEFINES) -o $@ format_output.c

ntdpal_main.o: ntdpal_main.c dpal.h
	$(CPP) -c $(CC_OPTS) -o $@ ntdpal_main.c

thal_main.o: thal_main.c thal.h
	$(CPP) -c $(CFLAGS) -o $@ thal_main.c
# We use CC_OPTS above rather than CFLAGS because
# gcc 2.7.2 crashes while compiling ntdpal_main.c with -O2

oligotm.o: oligotm.c oligotm.h

primer3_boulder_main.o: primer3_boulder_main.c libprimer3.h dpal.h thal.h oligotm.h format_output.h print_boulder.h read_boulder.h
	$(CPP) -c $(CFLAGS) $(P_DEFINES) primer3_boulder_main.c

masker.o: masker.c masker.h libprimer3.h
	$(CPP) -c $(CFLAGS) $(P_DEFINES) masker.c

primer_test: test

test: $(PRIMER_EXE) $(NTDPAL_EXE) $(NTTHAL_EXE)
ifeq ($(TESTOPTS),--windows)
	cd ..\test & $(WINMAKE) TESTOPTS=$(TESTOPTS)
else
	cd ../test; make test
endif

# ======================================================================
# 
# VALGRIND INSTRUCTIONS.
# 
# These instructions work for linux, and run the 'memcheck'
# functionality of valgrind.  Tests will be _much_ slower
# when running with valgrind checks.
# 
# If necessary, get and install valgrind (should come with most
# Linux's, but you need valgrind >= 3.2.3)
# 
# In the src directory for primer3:
#  
# $ make clean
# 
# Re-complile without optimization and run the normal tests, does
# _not_ valgrind them:
#
# $ make O_OPTS=-O0 test  # The value of O_OPTS is Minus Oh Zero 
# 
# Run valgrind on a small example:
#
# $ valgrind --leak-check=yes --show-reachable=yes --log-file-exactly=p3vg ./primer3_core < ../example
#
# Check output in file p3vg 
#
# Note: Valgrind is at /usr/local/bin/valgrind at WI
# 
# OK, now for the real tests:
#
# $ cd ../test
# 
# Check valgrind path in p3test.pl, ntdpal_test.pl, and oligotm_test.pl
# and correct if necessary.  This code works under valgrind 3.2.3.
# 
# $ make TESTOPTS=--valgrind  # Remember, you have to be in test/
# 
# When the --valgrind flag is set, the perl test scripts grep for and
# display errors and leaks, but you need to ***look at the output** to
# see these and figure out which test caused the problem, so you can
# debug it.
#
# ======================================================================

=== test/Makefile ===
# ======================================================================
# (c) Copyright 1996,1997,1998,1999,2000,2001,2004,2006,2007,2008,2009,
#       2010,2011
# Whitehead Institute for Biomedical Research, Steve Rozen, 
# Andreas Untergasser and Helen Skaletsky
# All rights reserved.
# 
#   This file is part of primer3, the libprimer3 library, the oligotm 
#   library and the dpal library.
#
#   Primer3 and the libraries above are free software; you can
#   redistribute them and/or modify them under the terms of the GNU
#   General Public License as published by the Free Software Foundation;
#   either version 2 of the License, or (at your option) any later
#   version.
#
#   This software is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this file (file gpl-2.0.txt in the source distribution); if
#   not, write to the Free Software Foundation, Inc., 51 Franklin St,
#   Fifth Floor, Boston, MA 02110-1301 USA
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# ======================================================================

WINMAKE=mingw32-make

# See ../src/Makefile for detailed instructions on how to use TESTOPTS
# The only valid non-empty values for TESTOPTS are --valgrind and --windows
TESTOPTS =


test: makeexes testcmdline testtm testdpal testthal testmasker testcore
	echo; echo; echo "Testing completed. You must check the test output for the string FAILED"; echo; echo;

testcmdline:
ifeq ($(TESTOPTS),--windows)
	perl cmdline_test.pl $(TESTOPTS)
else 
	perl cmdline_test.pl $(TESTOPTS)
endif

testcore:
ifeq ($(TESTOPTS),--windows)
	echo 'TESTING primer3_core' & perl p3test.pl $(TESTOPTS)
else
	echo; echo; echo 'TESTING primer3_core'; echo; perl p3test.pl $(TESTOPTS)
endif

testdpal:
ifeq ($(TESTOPTS),--windows)
	echo 'TESTING ALIGNMENT CALCS' & perl dpal_test.pl $(TESTOPTS)
else
	echo; echo; echo 'TESTING ALIGNMENT CALCS'; echo; perl dpal_test.pl $(TESTOPTS); 
endif

testthal:
ifeq ($(TESTOPTS),--windows)
	echo 'TESTING THERMODYNAMIC ALIGNMENT CALCS' & perl thal_test.pl $(TESTOPTS)
else
	echo; echo; echo 'TESTING THERMODYNAMIC ALIGNMENT CALCS'; echo; perl thal_test.pl $(TESTOPTS);
endif

testmasker:
ifeq ($(TESTOPTS),--windows)
	echo 'TESTING MASKER' & perl masker_test.pl $(TESTOPTS)
else
	echo; echo; echo 'TESTING MASKER'; echo; perl masker_test.pl $(TESTOPTS);
endif

testtm:
ifeq ($(TESTOPTS),--windows)
	perl oligotm_test.pl $(TESTOPTS)
else
	perl oligotm_test.pl $(TESTOPTS)
endif

makeexes:
ifeq ($(TESTOPTS),--windows)
	cd ..\src & $(WINMAKE)
else
	cd ../src; make
endif

clean:
ifeq ($(TESTOPTS),--windows)
	echo 'CLEAN UP TEST DIRECTORIES'
	del /Q /F primer1_list_tmp\*
	del /Q /F primer1_th_list_tmp\*
	del /Q /F primer_list_tmp\*
	del /Q /F th-w-other-tasks_list_tmp\*
	del /Q /F primer_global_err\*.tmp primer_global_err\*.tmp2 primer_global_err\*.bak
	del /Q /F *.tmp *.bak *.tmp.err *~
	del /Q /F hyb_probe_only.for hyb_probe_only.int 
	del /Q /F right_only.for right_only.rev left_only.for
	del /Q /F pcr_primers_and_io.int pcr_primers_and_io.rev pcr_primers_and_io.for
	del /Q /F pcr_primers.rev pcr_primers.for
	del /Q /F pick_primer_list_and_file_flag_th_*.for pick_primer_list_and_file_flag_th_*.rev
	del /Q /F pick_primer_list_and_file_flag_th_*.int
	del /Q /F syntax*.for syntax*.int syntax*.rev
else
	echo; echo; echo 'CLEAN UP TEST DIRECTORIES'; echo; echo;
	-rm -rf primer_list_tmp/*
	-rm -rf primer1_list_tmp/*
	-rm -rf primer1_th_list_tmp/*
	-rm -rf th-w-other-tasks_list_tmp/*
	-rm -f primer_global_err/*.tmp primer_global_err/*.tmp2 primer_global_err/*.bak
	-rm -f *.tmp *.bak *.tmp.err *~
	-rm -f hyb_probe_only.for hyb_probe_only.int 
	-rm -f right_only.for right_only.rev left_only.for
	-rm -f pcr_primers_and_io.int pcr_primers_and_io.rev pcr_primers_and_io.for
	-rm -f pcr_primers.rev pcr_primers.for
	-rm -f pick_primer_list_and_file_flag_th_[1-4].for pick_primer_list_and_file_flag_th_[1-4].rev
	-rm -f pick_primer_list_and_file_flag_th_[1-4].int
	-rm -f syntax[0-1][0-9].for syntax[0-1][0-9].int syntax[0-1][0-9].rev
	-rm -f oligotm.*.valg    # valgrind output from oligotm_test.pl --valgrind
	-rm -f ntdpal.*.valg     # valgrind output from dpal_test.pl --valgrind
	-rm -f ntthal.*.valg     # valgrind output from thal_test.pl --valgrind
	-rm -f masker.*.valg     # valgrind output from thal_test.pl --valgrind
	-rm -f oligotm.*.valg.*  # valgrind output from oligotm_test.pl --valgrind
	-rm -f ntdpal.*.valg.*   # valgrind output from dpal_test.pl --valgrind
	-rm -f ntthal.*.valg.*   # valgrind output from thal_test.pl --valgrind
	-rm -f masker.*.valg.*   # valgrind output from masker_test.pl --valgrind
	-rm -f *.vg */*.vg       # valgrind output from p3test{,z}.pl --valgrind
	-rm -f *.vg.core.*       # core files from crashed valgrind test
	-rm -f ./core # in case we crashed and left a core file
endif

=== debian/changelog ===
primer3 (2.4.0-4) unstable; urgency=medium

  * Team upload
  * Fixup syntax skip for big endian platforms.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 02 Jul 2020 22:12:20 +0200

primer3 (2.4.0-3) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Also skip autopkgtests that fail on big endian (see: 890993)
    Closes: #962190

  [ Andreas Tille ]
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Secure URI in copyright format (routine-update)
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target (routine-
    update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Trim trailing whitespace.
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Set fields Upstream-Name, Upstream-Contact in debian/copyright.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata (already
    present in machine-readable debian/copyright).
  * Fix day-of-week for changelog entry 0.9-0.2.

 -- Andreas Tille <tille@debian.org>  Thu, 02 Jul 2020 08:10:35 +0200

primer3 (2.4.0-2) unstable; urgency=medium

  [ Liubov Chuprikova ]
  * Team upload.
  * Skip tests that fail on big endian
    Closes: #890993
  * Added d/README.source with explanation why some tests are skipped
  * debian/patches/p3test_fix_exit_status.patch: Fix test to show correct exit
    status

  [ Andreas Tille ]
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.4

 -- Liubov Chuprikova <chuprikovalv@gmail.com>  Mon, 28 May 2018 13:44:30 +0000

primer3 (2.4.0-1) unstable; urgency=medium

  * New upstream version
  * Secure URI in watch file
  * Standards-Version: 4.1.3
  * debhelper 11

 -- Andreas Tille <tille@debian.org>  Wed, 21 Feb 2018 09:21:42 +0100

primer3 (2.3.7-5) unstable; urgency=medium

  * d/upstream/metadata:
    - Added references to registries
    - yamllint cleanliness

 -- Steffen Moeller <moeller@debian.org>  Thu, 14 Sep 2017 15:05:29 +0200

primer3 (2.3.7-4) unstable; urgency=medium

  * Fix build with gcc-7
    Closes: #853621
  * Standards-Version: 4.1.0 (no changes needed)
  * d/rules: use DEB_SOURCE
  * hardening=+all

 -- Andreas Tille <tille@debian.org>  Sat, 26 Aug 2017 06:55:03 +0200

=== debian/control ===
--- 
+++ 
@@ -5,11 +5,12 @@
            Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 10)
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/primer3.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/primer3.git
+Build-Depends: debhelper-compat (= 13)
+Standards-Version: 4.5.0
+Vcs-Browser: https://salsa.debian.org/med-team/primer3
+Vcs-Git: https://salsa.debian.org/med-team/primer3.git
 Homepage: http://primer3.sourceforge.net
+Rules-Requires-Root: no
 
 Package: primer3
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk

sampledir:=$(CURDIR)/debian/$(DEB_SOURCE)-examples/usr/share/doc/$(DEB_SOURCE)/examples

BUILDARCH:=$(shell dpkg-architecture -q DEB_BUILD_ARCH_ENDIAN)

P3CORE_FAILED_TESTS:='primer_masker' \
	      'primer_masker_formatted'

FAILED_TESTS:=testmasker

%:
	dh $@ --sourcedirectory=src

override_dh_auto_build:
	dh_auto_build -- 'CPP=$$(CXX)'

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifneq ($(BUILDARCH),little)
	cp -a test/p3test.pl test/p3test.pl~
	cp -a test/Makefile test/Makefile~
	# exclude tests known to fail on big endian
	# See README.source for further explanation.
	for tst in $(P3CORE_FAILED_TESTS) ; do sed -i "/$${tst}/d" test/p3test.pl ; done
	sed -i "0,/$(FAILED_TESTS)/s///" test/Makefile
	sed -i "/$(FAILED_TESTS)/,/endif/d" test/Makefile
endif
	dh_auto_test --sourcedirectory=test
ifneq ($(BUILDARCH),little)
	# restore original test file
	mv test/p3test.pl~ test/p3test.pl
	mv test/Makefile~ test/Makefile
endif
	dh clean --sourcedirectory=test
endif

override_dh_installexamples:
	dh_installexamples
	mkdir -p $(sampledir)/test;
	mkdir -p $(sampledir)/src;
	mkdir -p $(sampledir)/settings_files;
	mkdir -p $(sampledir)/kmer_lists;
	cp -aR ./test/* $(sampledir)/test;
	cp -aR ./src/humrep_and_simple.txt $(sampledir)/src;
	cp -a settings_files/primer*.txt $(sampledir)/settings_files;
	cp -aR ./kmer_lists/*.list $(sampledir)/kmer_lists;

	chmod -x $(sampledir)/test/thal*;
	sed -i 's#/usr/local/bin/perl#/usr/bin/perl#' $(sampledir)/test/long_seq_tm_test.pl ;
	sed -i 's#/usr/local/bin/perl#/usr/bin/perl#' $(sampledir)/test/vgrep.pl ;

=== debian/watch ===
version=4
# formerly
#https://sf.net/primer3/primer3-[-src]*([\d.]*)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
# conda new about this new URL on github
https://github.com/primer3-org/primer3/releases .*/archive/V(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## primer3 2.5.0

=== src/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # ======================================================================
-# (c) Copyright 1996,1997,1998,1999,2000,2001,2004,2006,2007,2008,2009
+# (c) Copyright 1996 - 2018
 # Whitehead Institute for Biomedical Research, Steve Rozen, 
 # Andreas Untergasser and Helen Skaletsky
 # All rights reserved.
@@ -48,21 +48,25 @@
 
 # For VALGRIND -- see end of this makefile for testing primer3_core
 # with valgrind, a leak and memory access checker.
-TESTOPTS= 
+TESTOPTS=
 WINMAKE=mingw32-make
 
 LDLIBS     = -lm
 AR         = ar
 CC         = gcc
-CPP        = g++
+CXX        = g++
 O_OPTS     = -O2
-CC_OPTS    = -g -Wall -D__USE_FIXED_PROTOTYPES__
+CC_OPTS    = -g -Wall
 P_DEFINES  =
 
 CFLAGS  = $(CC_OPTS) $(O_OPTS)
+CXXFLAGS = $(CFLAGS) -std=c++11
 LDFLAGS = -g
 # Note, for profiling, use
 # make O_OPTS='-pg -O0' LDFLAGS='-g -pg'
+
+# Target installation directory
+PREFIX     = /usr/local
 
 # ======================================================================
 # If you have trouble with library skew when moving primer3 executables
@@ -75,7 +79,6 @@
 	NTTHAL_EXE      = ntthal.exe
 	OLIGOTM_EXE     = oligotm.exe
 	LONG_SEQ_EXE	= long_seq_tm_test.exe
-	MASKER_EXE      = primer3_masker.exe
 else
 	PRIMER_EXE      = primer3_core
 	NTDPAL_EXE      = ntdpal
@@ -90,26 +93,40 @@
 LIBDPAL_DYN     = libdpal.a.so.1.0.0
 LIBTHAL         = libthal.a
 LIBTHAL_DYN     = libthal.a.so.1.0.0
+LIBTHALPARA     = libthalpara.a
+LIBTHALPARA_DYN = libthalpara.a.so.1.0.0
 LIBPRIMER3      = libprimer3.a
 LIBPRIMER3_DYN  = libprimer3.so.1.0.0
-LIBMASKER       = libmasker.a
-LIBMASKER_DYN   = libmasker.a.so.1.0.0
-LIBRARIES       = $(LIBPRIMER3) $(LIBDPAL) $(LIBTHAL) $(LIBOLIGOTM) $(LIBMASKER)
-DYNLIBS         = $(LIBPRIMER3_DYN) $(LIBDPAL_DYN) $(LIBTHAL_DYN) $(LIBOLIGOTM_DYN) $(LIBMASKER_DYN)
+
+ifeq ($(TESTOPTS),--windows)
+    $(info windows)
+    LIBRARIES       = $(LIBPRIMER3) $(LIBDPAL) $(LIBTHAL) $(LIBTHALPARA) $(LIBOLIGOTM)
+    DYNLIBS         = $(LIBPRIMER3_DYN) $(LIBDPAL_DYN) $(LIBTHAL_DYN) $(LIBTHALPARA_DYN) $(LIBOLIGOTM_DYN)
+else
+    $(info no windows)
+    LIBMASKER       = libmasker.a
+    LIBMASKER_DYN   = libmasker.a.so.1.0.0
+    LIBRARIES       = $(LIBPRIMER3) $(LIBDPAL) $(LIBTHAL) $(LIBTHALPARA) $(LIBOLIGOTM) $(LIBMASKER)
+    DYNLIBS         = $(LIBPRIMER3_DYN) $(LIBDPAL_DYN) $(LIBTHAL_DYN) $(LIBTHALPARA_DYN) $(LIBOLIGOTM_DYN) $(LIBMASKER_DYN)
+endif
+
 RANLIB          = ranlib
 
 PRIMER_OBJECTS1=primer3_boulder_main.o\
                 format_output.o\
                 read_boulder.o\
-                print_boulder.o\
-                masker.o
+                print_boulder.o
 
 PRIMER_OBJECTS=$(PRIMER_OBJECTS1) $(LIBRARIES)
 PRIMER_DYN_OBJECTS=$(PRIMER_OBJECTS1) $(DYNLIBS)
 # These are files generated by running ./primer3_core < ../example
 example_files=example.for example.rev example.int
 
-EXES=$(PRIMER_EXE) $(NTDPAL_EXE) $(NTTHAL_EXE) $(OLIGOTM_EXE) $(LONG_SEQ_EXE) $(MASKER_EXE)
+ifeq ($(TESTOPTS),--windows)
+    EXES=$(PRIMER_EXE) $(NTDPAL_EXE) $(NTTHAL_EXE) $(OLIGOTM_EXE) $(LONG_SEQ_EXE)
+else
+    EXES=$(PRIMER_EXE) $(NTDPAL_EXE) $(NTTHAL_EXE) $(OLIGOTM_EXE) $(LONG_SEQ_EXE) $(MASKER_EXE)
+endif
 
 all: $(EXES) $(LIBRARIES)
 
@@ -147,6 +164,13 @@
 
 $(LIBTHAL_DYN): thal_primer.o
 	$(CC) -shared -W1,-soname,libthal.so.1 -o $(LIBTHAL_DYN_LIB) thal_primer.o
+
+$(LIBTHALPARA): thal_parameters.o
+	$(AR) rv $@ thal_parameters.o
+	$(RANLIB) $@
+
+$(LIBTHALPARA_DYN): thal_parameters.o
+	$(CC) -shared -W1,-soname,libthalpara.so.1 -o $(LIBTHALPARA_DYN_LIB) thal_parameters.o
 
 $(LIBPRIMER3): libprimer3.o p3_seq_lib.o
 	$(AR) rv $@ libprimer3.o p3_seq_lib.o
@@ -163,67 +187,70 @@
 	$(CC) -shared -W1,-soname,libmasker.so.1 -o $(LIBMASKER_DYN) masker.o
 
 $(PRIMER_EXE): $(PRIMER_OBJECTS)
-	$(CPP) $(LDFLAGS) -o $@ $(PRIMER_OBJECTS) $(LIBOPTS) $(LDLIBS)
-
-libprimer3.o: libprimer3.c libprimer3.h p3_seq_lib.h dpal.h thal.h oligotm.h
-	$(CPP) -c $(CFLAGS) -Wno-deprecated $(P_DEFINES) -o $@ libprimer3.c
+	$(CXX) $(CXXFLAGS) -lstdc++ $(LDFLAGS) -o $@ $(PRIMER_OBJECTS) $(LIBOPTS) $(LDLIBS)
+
+libprimer3.o: libprimer3.cc libprimer3.h p3_seq_lib.h dpal.h thal.h thal_parameters.h oligotm.h
+	$(CXX) -c $(CXXFLAGS) $(P_DEFINES) -o $@ libprimer3.cc
 
 $(NTDPAL_EXE): ntdpal_main.o dpal.o
-	$(CPP) $(LDFLAGS) -o $@ ntdpal_main.o dpal.o
-
-$(NTTHAL_EXE): thal_main.o thal.o
-	$(CPP) $(LDFLAGS) -o $@ thal_main.o thal.o $(LDLIBS)
+	$(CC) $(LDFLAGS) -o $@ ntdpal_main.o dpal.o
+
+$(NTTHAL_EXE): thal_main.o thal.o thal_parameters.o
+	$(CC) $(LDFLAGS) -o $@ thal_main.o thal.o thal_parameters.o $(LDLIBS)
 
 $(OLIGOTM_EXE): oligotm_main.c oligotm.h $(LIBOLIGOTM)
-	$(CPP) $(CFLAGS) -o $@ oligotm_main.c $(LIBOLIGOTM) $(LIBOPTS) $(LDLIBS)
+	$(CC) $(CFLAGS) -o $@ oligotm_main.c $(LIBOLIGOTM) $(LIBOPTS) $(LDLIBS)
 
 $(LONG_SEQ_EXE): long_seq_tm_test_main.c oligotm.o
-	$(CPP) $(CFLAGS) -o $@ long_seq_tm_test_main.c oligotm.o $(LIBOPTS) $(LDLIBS)
+	$(CC) $(CFLAGS) -o $@ long_seq_tm_test_main.c oligotm.o $(LIBOPTS) $(LDLIBS)
 
 $(MASKER_EXE): masker_main.c $(LIBRARIES)
-	$(CPP) $(CFLAGS) -o $@ masker_main.c $(LIBRARIES) $(LIBOPTS) $(LDLIBS)
-
-read_boulder.o: read_boulder.c read_boulder.h libprimer3.h dpal.h thal.h p3_seq_lib.h 
-	$(CPP) -c $(CFLAGS) $(P_DEFINES) -o $@ read_boulder.c
+	$(CXX) $(CXXFLAGS) -lstdc++ -o $@ masker_main.c $(LIBRARIES) $(LIBOPTS) $(LDLIBS)
+
+read_boulder.o: read_boulder.c read_boulder.h libprimer3.h dpal.h thal.h thal_parameters.h p3_seq_lib.h 
+	$(CC) -c $(CFLAGS) $(P_DEFINES) -o $@ read_boulder.c
 
 print_boulder.o: print_boulder.c print_boulder.h libprimer3.h p3_seq_lib.h 
-	$(CPP) -c $(CFLAGS) $(P_DEFINES) -o $@ print_boulder.c
+	$(CC) -c $(CFLAGS) $(P_DEFINES) -o $@ print_boulder.c
 
 dpal.o: dpal.c dpal.h
-	$(CPP) -c $(CFLAGS) -o $@ dpal.c
+	$(CC) -c $(CFLAGS) -o $@ dpal.c
 
 # We use '-ffloat-store' on windows to prevent undesirable
 # precision which may lead to differences in floating point results.
-thal.o: thal.c thal.h
-	$(CPP) -c $(CFLAGS) -ffloat-store -o $@ thal.c
+thal.o: thal.c thal.h thal_parameters.h
+	$(CC) -c $(CFLAGS) -ffloat-store -o $@ thal.c
+
+thal_parameters.o: thal_parameters.c thal_parameters.h thal.h
+	$(CC) -c $(CFLAGS) -ffloat-store $(P_DEFINES) -o $@ thal_parameters.c
 
 p3_seq_lib.o: p3_seq_lib.c p3_seq_lib.h libprimer3.h
-	$(CPP) -c $(CFLAGS) -o $@ p3_seq_lib.c
+	$(CC) -c $(CFLAGS) -o $@ p3_seq_lib.c
 
 dpal_primer.o: dpal.c dpal.h
-	$(CPP) -c $(CFLAGS) $(P_DEFINES) -o $@ dpal.c
-
-thal_primer.o: thal.c thal.h
-	$(CPP) -c $(CFLAGS) -ffloat-store $(P_DEFINES) -o $@ thal.c
+	$(CC) -c $(CFLAGS) $(P_DEFINES) -o $@ dpal.c
+
+thal_primer.o: thal.c thal.h thal_parameters.h
+	$(CC) -c $(CFLAGS) -ffloat-store $(P_DEFINES) -o $@ thal.c
 
 format_output.o: format_output.c format_output.h libprimer3.h dpal.h thal.h p3_seq_lib.h 
-	$(CPP) -c $(CFLAGS) $(P_DEFINES) -o $@ format_output.c
+	$(CC) -c $(CFLAGS) $(P_DEFINES) -o $@ format_output.c
 
 ntdpal_main.o: ntdpal_main.c dpal.h
-	$(CPP) -c $(CC_OPTS) -o $@ ntdpal_main.c
-
-thal_main.o: thal_main.c thal.h
-	$(CPP) -c $(CFLAGS) -o $@ thal_main.c
+	$(CC) -c $(CC_OPTS) -o $@ ntdpal_main.c
+
+thal_main.o: thal_main.c thal.h thal_parameters.h
+	$(CC) -c $(CFLAGS) -o $@ thal_main.c
 # We use CC_OPTS above rather than CFLAGS because
 # gcc 2.7.2 crashes while compiling ntdpal_main.c with -O2
 
 oligotm.o: oligotm.c oligotm.h
 
-primer3_boulder_main.o: primer3_boulder_main.c libprimer3.h dpal.h thal.h oligotm.h format_output.h print_boulder.h read_boulder.h
-	$(CPP) -c $(CFLAGS) $(P_DEFINES) primer3_boulder_main.c
+primer3_boulder_main.o: primer3_boulder_main.c libprimer3.h dpal.h thal.h thal_parameters.h oligotm.h format_output.h print_boulder.h read_boulder.h
+	$(CC) -c $(CFLAGS) $(P_DEFINES) primer3_boulder_main.c
 
 masker.o: masker.c masker.h libprimer3.h
-	$(CPP) -c $(CFLAGS) $(P_DEFINES) masker.c
+	$(CC) -c $(CFLAGS) $(P_DEFINES) masker.c
 
 primer_test: test
 
@@ -233,6 +260,10 @@
 else
 	cd ../test; make test
 endif
+
+install: $(EXES) $(LIBRARIES)
+	install -d "$(PREFIX)/bin"
+	install -m 755 $(EXES) "$(PREFIX)/bin"
 
 # ======================================================================
 #

=== debian/changelog ===
primer3 (2.5.0-1) unstable; urgency=medium

  * Fix watchfile to detect new versions on github
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)
  * Apply multi-arch hints.
    + primer3-examples: Add Multi-Arch: foreign.
  * Fix PREFIX

 -- Andreas Tille <tille@debian.org>  Fri, 15 Oct 2021 15:20:35 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13)
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/primer3
 Vcs-Git: https://salsa.debian.org/med-team/primer3.git
 Homepage: http://primer3.sourceforge.net
@@ -30,6 +30,7 @@
 Architecture: all
 Depends: ${misc:Depends}
 Suggests: primer3
+Multi-Arch: foreign
 Description: tool to design flanking oligo nucleotides for DNA amplification (examples)
  Primer3 picks primers for Polymerase Chain Reactions (PCRs), considering as
  criteria oligonucleotide melting temperature, size, GC content and

=== debian/rules ===
--- 
+++ 
@@ -18,6 +18,9 @@
 
 override_dh_auto_build:
 	dh_auto_build -- 'CPP=$$(CXX)'
+
+override_dh_auto_install:
+	dh_auto_install -- PREFIX=debian/$(DEB_SOURCE)/usr
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))

## primer3 2.6.1

=== src/Makefile ===
--- 
+++ 
@@ -78,17 +78,21 @@
 	NTDPAL_EXE      = ntdpal.exe
 	NTTHAL_EXE      = ntthal.exe
 	OLIGOTM_EXE     = oligotm.exe
+	AMPLICONTM_EXE  = amplicon3_core.exe
 	LONG_SEQ_EXE	= long_seq_tm_test.exe
 else
 	PRIMER_EXE      = primer3_core
 	NTDPAL_EXE      = ntdpal
 	NTTHAL_EXE      = ntthal
 	OLIGOTM_EXE     = oligotm
+	AMPLICONTM_EXE  = amplicon3_core
 	LONG_SEQ_EXE	= long_seq_tm_test
 	MASKER_EXE      = primer3_masker
 endif
 LIBOLIGOTM      = liboligotm.a
 LIBOLIGOTM_DYN  = liboligotm.so.1.2.0
+LIBAMPTM        = libamplicontm.a
+LIBAMPTM_DYN    = libamplicontm.so.1.0.0
 LIBDPAL         = libdpal.a
 LIBDPAL_DYN     = libdpal.a.so.1.0.0
 LIBTHAL         = libthal.a
@@ -100,14 +104,14 @@
 
 ifeq ($(TESTOPTS),--windows)
     $(info windows)
-    LIBRARIES       = $(LIBPRIMER3) $(LIBDPAL) $(LIBTHAL) $(LIBTHALPARA) $(LIBOLIGOTM)
-    DYNLIBS         = $(LIBPRIMER3_DYN) $(LIBDPAL_DYN) $(LIBTHAL_DYN) $(LIBTHALPARA_DYN) $(LIBOLIGOTM_DYN)
+    LIBRARIES       = $(LIBPRIMER3) $(LIBDPAL) $(LIBTHAL) $(LIBTHALPARA) $(LIBAMPTM) $(LIBOLIGOTM)
+    DYNLIBS         = $(LIBPRIMER3_DYN) $(LIBDPAL_DYN) $(LIBTHAL_DYN) $(LIBTHALPARA_DYN) $(LIBAMPTM_DYN) $(LIBOLIGOTM_DYN)
 else
     $(info no windows)
     LIBMASKER       = libmasker.a
     LIBMASKER_DYN   = libmasker.a.so.1.0.0
-    LIBRARIES       = $(LIBPRIMER3) $(LIBDPAL) $(LIBTHAL) $(LIBTHALPARA) $(LIBOLIGOTM) $(LIBMASKER)
-    DYNLIBS         = $(LIBPRIMER3_DYN) $(LIBDPAL_DYN) $(LIBTHAL_DYN) $(LIBTHALPARA_DYN) $(LIBOLIGOTM_DYN) $(LIBMASKER_DYN)
+    LIBRARIES       = $(LIBPRIMER3) $(LIBDPAL) $(LIBTHAL) $(LIBTHALPARA) $(LIBOLIGOTM) $(LIBAMPTM) $(LIBMASKER)
+    DYNLIBS         = $(LIBPRIMER3_DYN) $(LIBDPAL_DYN) $(LIBTHAL_DYN) $(LIBTHALPARA_DYN) $(LIBAMPTM_DYN) $(LIBOLIGOTM_DYN) $(LIBMASKER_DYN)
 endif
 
 RANLIB          = ranlib
@@ -123,23 +127,23 @@
 example_files=example.for example.rev example.int
 
 ifeq ($(TESTOPTS),--windows)
-    EXES=$(PRIMER_EXE) $(NTDPAL_EXE) $(NTTHAL_EXE) $(OLIGOTM_EXE) $(LONG_SEQ_EXE)
-else
-    EXES=$(PRIMER_EXE) $(NTDPAL_EXE) $(NTTHAL_EXE) $(OLIGOTM_EXE) $(LONG_SEQ_EXE) $(MASKER_EXE)
+    EXES=$(PRIMER_EXE) $(NTDPAL_EXE) $(NTTHAL_EXE) $(AMPLICONTM_EXE) $(OLIGOTM_EXE) $(LONG_SEQ_EXE)
+else
+    EXES=$(PRIMER_EXE) $(NTDPAL_EXE) $(NTTHAL_EXE) $(AMPLICONTM_EXE) $(OLIGOTM_EXE) $(LONG_SEQ_EXE) $(MASKER_EXE)
 endif
 
 all: $(EXES) $(LIBRARIES)
 
 clean_src:
 ifeq ($(TESTOPTS),--windows)
-	del /Q /F *.o $(EXES) *~ $(LIBRARIES) $(example_files) core ..\*~
+	del /Q /F *.o $(EXES) *~ $(LIBRARIES) $(example_files) core ../*~
 else
 	-rm -f *.o $(EXES) *~ $(LIBRARIES) $(DYNLIBS) $(example_files) core ../*~
 endif
 
 clean: clean_src
 ifeq ($(TESTOPTS),--windows)
-	cd ..\test & $(WINMAKE) clean TESTOPTS=$(TESTOPTS)
+	cd ../test & $(WINMAKE) clean TESTOPTS=$(TESTOPTS)
 else
 	cd ../test/; make clean
 endif
@@ -151,6 +155,13 @@
 $(LIBOLIGOTM_LIB): oligotm.o
 	$(CC) -shared -W1,-soname,liboligotm.so.1 -o $(LIBOLIGOTM_DYN) oligotm.o
 
+$(LIBAMPTM): amplicontm.o
+	$(AR) rv $@ amplicontm.o
+	$(RANLIB) $@
+
+$(LIBAMPTM_LIB): amplicontm.o
+	$(CC) -shared -W1,-soname,libamplicontm.so.1 -o $(LIBAMPTM_DYN) amplicontm.o
+
 $(LIBDPAL): dpal_primer.o
 	$(AR) rv $@ dpal_primer.o
 	$(RANLIB) $@
@@ -182,7 +193,7 @@
 $(LIBMASKER): masker.o
 	$(AR) rv $@ masker.o
 	$(RANLIB) $@
-               
+
 $(LIBMASKER_DYN): masker.o
 	$(CC) -shared -W1,-soname,libmasker.so.1 -o $(LIBMASKER_DYN) masker.o
 
@@ -200,6 +211,9 @@
 
 $(OLIGOTM_EXE): oligotm_main.c oligotm.h $(LIBOLIGOTM)
 	$(CC) $(CFLAGS) -o $@ oligotm_main.c $(LIBOLIGOTM) $(LIBOPTS) $(LDLIBS)
+
+$(AMPLICONTM_EXE): amplicontm_main.c amplicontm.h $(LIBAMPTM)
+	$(CC) $(CFLAGS) -o $@ amplicontm_main.c $(LIBAMPTM) $(LIBOPTS) $(LDLIBS)
 
 $(LONG_SEQ_EXE): long_seq_tm_test_main.c oligotm.o
 	$(CC) $(CFLAGS) -o $@ long_seq_tm_test_main.c oligotm.o $(LIBOPTS) $(LDLIBS)
@@ -244,6 +258,8 @@
 # We use CC_OPTS above rather than CFLAGS because
 # gcc 2.7.2 crashes while compiling ntdpal_main.c with -O2
 
+amplicontm.o: amplicontm.c amplicontm.h
+
 oligotm.o: oligotm.c oligotm.h
 
 primer3_boulder_main.o: primer3_boulder_main.c libprimer3.h dpal.h thal.h thal_parameters.h oligotm.h format_output.h print_boulder.h read_boulder.h
@@ -256,7 +272,7 @@
 
 test: $(PRIMER_EXE) $(NTDPAL_EXE) $(NTTHAL_EXE)
 ifeq ($(TESTOPTS),--windows)
-	cd ..\test & $(WINMAKE) TESTOPTS=$(TESTOPTS)
+	cd ../test & $(WINMAKE) TESTOPTS=$(TESTOPTS)
 else
 	cd ../test; make test
 endif

=== test/Makefile ===
--- 
+++ 
@@ -44,8 +44,15 @@
 TESTOPTS =
 
 
-test: makeexes testcmdline testtm testdpal testthal testmasker testcore
+test: makeexes testcmdline testtm testdpal testthal testmasker testamp testcore
 	echo; echo; echo "Testing completed. You must check the test output for the string FAILED"; echo; echo;
+
+valgrnda: makeexes testcmdline testtm testdpal testthal testmasker testampa testcorea
+	echo; echo; echo "Testing completed. You must check the test output for the string FAILED"; echo; echo;
+
+valgrndb: testcoreb
+	echo; echo; echo "Testing completed. You must check the test output for the string FAILED"; echo; echo;
+
 
 testcmdline:
 ifeq ($(TESTOPTS),--windows)
@@ -60,6 +67,22 @@
 else
 	echo; echo; echo 'TESTING primer3_core'; echo; perl p3test.pl $(TESTOPTS)
 endif
+
+testamp:
+ifeq ($(TESTOPTS),--windows)
+	echo 'TESTING amplicon3_core' & perl a3test.pl $(TESTOPTS)
+else
+	echo; echo; echo 'TESTING amplicon3_core'; echo; perl a3test.pl $(TESTOPTS)
+endif
+
+testampa:
+	echo; echo; echo 'TESTING primer3_core'; echo; perl a3test.pl --valgrinda
+
+testcorea:
+	echo; echo; echo 'TESTING primer3_core'; echo; perl p3test.pl --valgrinda
+
+testcoreb:
+	echo; echo; echo 'TESTING primer3_core'; echo; perl p3test.pl --valgrindb
 
 testdpal:
 ifeq ($(TESTOPTS),--windows)
@@ -91,7 +114,7 @@
 
 makeexes:
 ifeq ($(TESTOPTS),--windows)
-	cd ..\src & $(WINMAKE)
+	cd ../src & $(WINMAKE)
 else
 	cd ../src; make
 endif
@@ -99,13 +122,14 @@
 clean:
 ifeq ($(TESTOPTS),--windows)
 	echo 'CLEAN UP TEST DIRECTORIES'
-	del /Q /F primer1_list_tmp\*
-	del /Q /F primer1_th_list_tmp\*
-	del /Q /F primer_list_tmp\*
-	del /Q /F th-w-other-tasks_list_tmp\*
-	del /Q /F primer_global_err\*.tmp primer_global_err\*.tmp2 primer_global_err\*.bak
+	del /Q /F primer1_list_tmp/*
+	del /Q /F primer1_th_list_tmp/*
+	del /Q /F primer_list_tmp/*
+	del /Q /F th-w-other-tasks_list_tmp/*
+	del /Q /F primer_global_err/*.tmp primer_global_err/*.tmp2 primer_global_err/*.bak
+	del /Q /F amplicon3/*.tm pamplicon3/*.jpg amplicon3/decipher*
 	del /Q /F *.tmp *.bak *.tmp.err *~
-	del /Q /F hyb_probe_only.for hyb_probe_only.int 
+	del /Q /F hyb_probe_only.for hyb_probe_only.int
 	del /Q /F right_only.for right_only.rev left_only.for
 	del /Q /F pcr_primers_and_io.int pcr_primers_and_io.rev pcr_primers_and_io.for
 	del /Q /F pcr_primers.rev pcr_primers.for
@@ -119,6 +143,7 @@
 	-rm -rf primer1_th_list_tmp/*
 	-rm -rf th-w-other-tasks_list_tmp/*
 	-rm -f primer_global_err/*.tmp primer_global_err/*.tmp2 primer_global_err/*.bak
+	-rm -f amplicon3/*.tmp amplicon3/*.jpg amplicon3/decipher*
 	-rm -f *.tmp *.bak *.tmp.err *~
 	-rm -f hyb_probe_only.for hyb_probe_only.int 
 	-rm -f right_only.for right_only.rev left_only.for

=== debian/changelog ===
primer3 (2.6.1-6) unstable; urgency=medium

  * Team upload.
  * gcc15.patch: new: remove SunOS workaround.
    This allows fixing a build failure with gcc-15. (Closes: #1097649)
  * d/copyright: remove the old fsf address.
  * d/watch: convert to v5 github template.
  * d/control: declare compliance to standards version 4.7.2.
  * d/control: drop redundant Rules-Requires-Root: no.

 -- Étienne Mollier <emollier@debian.org>  Mon, 06 Oct 2025 22:24:23 +0200

primer3 (2.6.1-5) unstable; urgency=medium

  * Team upload.
  * Clean up source directory properly (Closes: #1045454)
  * Use execute_after hook over overrides in d/rules
  * Bump standards version to 4.7.0 (no changes needed)
  * Correct patch header metadata
  * Drop deprecated an-trap macro from manpage

 -- Ananthu C V <weepingclown@disroot.org>  Sun, 01 Dec 2024 17:24:55 +0530

primer3 (2.6.1-4) unstable; urgency=medium

  * Team upload.

  [ Lukas Märdian ]
  * d/t/run-unit-test: fix autopkgtest sed commands on s390x.
    (Closes: #1023823)

 -- Étienne Mollier <emollier@debian.org>  Sun, 13 Nov 2022 11:49:48 +0100

primer3 (2.6.1-3) unstable; urgency=medium

  * Team upload.

  [ Steve Langasek ]
  * d/rules: fix handling of big-endian archs. (Closes: #1014626)

  [ Étienne Mollier ]
  * Standards-Version: 4.6.1 (routine-update)
  * d/primer3-examples.lintian-overrides: refresh override.
  * d/rules: remove executable bit to samples.
  * Add buildflags.patch: propagate Debian build flags.

 -- Étienne Mollier <emollier@debian.org>  Sat, 09 Jul 2022 10:50:59 +0200

primer3 (2.6.1-2) unstable; urgency=medium

  * Run dh_auto_test with --no-parallel

 -- Andreas Tille <tille@debian.org>  Sat, 19 Feb 2022 17:57:05 +0100

primer3 (2.6.1-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Thu, 17 Feb 2022 15:38:18 +0100

=== debian/control ===
--- 
+++ 
@@ -6,11 +6,10 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13)
-Standards-Version: 4.6.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/primer3
 Vcs-Git: https://salsa.debian.org/med-team/primer3.git
 Homepage: http://primer3.sourceforge.net
-Rules-Requires-Root: no
 
 Package: primer3
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -29,11 +29,10 @@
 	cp -a test/Makefile test/Makefile~
 	# exclude tests known to fail on big endian
 	# See README.source for further explanation.
-	for tst in $(P3CORE_FAILED_TESTS) ; do sed -i "/$${tst}/d" test/p3test.pl ; done
-	sed -i "0,/$(FAILED_TESTS)/s///" test/Makefile
-	sed -i "/$(FAILED_TESTS)/,/endif/d" test/Makefile
+	for tst in $(P3CORE_FAILED_TESTS) ; do sed -i "/$${tst}.,/d" test/p3test.pl ; done
+	for tst in $(FAILED_TESTS); do sed -i "/^test:/s/$$tst//" test/Makefile; done
 endif
-	dh_auto_test --sourcedirectory=test
+	dh_auto_test --no-parallel --sourcedirectory=test
 ifneq ($(BUILDARCH),little)
 	# restore original test file
 	mv test/p3test.pl~ test/p3test.pl
@@ -42,8 +41,7 @@
 	dh clean --sourcedirectory=test
 endif
 
-override_dh_installexamples:
-	dh_installexamples
+execute_after_dh_installexamples:
 	mkdir -p $(sampledir)/test;
 	mkdir -p $(sampledir)/src;
 	mkdir -p $(sampledir)/settings_files;
@@ -52,7 +50,11 @@
 	cp -aR ./src/humrep_and_simple.txt $(sampledir)/src;
 	cp -a settings_files/primer*.txt $(sampledir)/settings_files;
 	cp -aR ./kmer_lists/*.list $(sampledir)/kmer_lists;
-
-	chmod -x $(sampledir)/test/thal*;
+	chmod -x $(sampledir)/test/thal*
+	chmod -x $(sampledir)/test/amplicon3/amplicons.csv
+	chmod -x $(sampledir)/test/primer_windows_newlines_input
 	sed -i 's#/usr/local/bin/perl#/usr/bin/perl#' $(sampledir)/test/long_seq_tm_test.pl ;
 	sed -i 's#/usr/local/bin/perl#/usr/bin/perl#' $(sampledir)/test/vgrep.pl ;
+
+execute_after_dh_auto_clean:
+	rm -rf ${CURDIR}/src/debian

=== debian/tests/control ===
Tests: run-unit-test
Depends: valgrind, @
Restrictions:

=== debian/watch ===
Version: 5

Template: Github
Owner: primer3-org
Project: primer3
